lkml.org 
[lkml]   [2016]   [Feb]   [4]   [last100]   RSS Feed
Views: [wrap][no wrap]   [headers]  [forward] 
 
Messages in this thread
Patch in this message
/
From
Subject[PATCH] scripts/link-vmlinux.sh: force error on kallsyms failure
Date
Since the output of the invocation of scripts/kallsyms is piped directly
into the assembler, error messages it emits are visible on stderr, but
a non-zero return code is ignored, and the build simply proceeds in that
case. However, the resulting kernel is most likely broken, and will crash
at boot. So capture the return code of scripts/kallsyms explicitly (in a
POSIX shell compatible manner), and abort the script if it is non-zero.

Signed-off-by: Ard Biesheuvel <ard.biesheuvel@linaro.org>
---
scripts/link-vmlinux.sh | 9 ++++++---
1 file changed, 6 insertions(+), 3 deletions(-)

diff --git a/scripts/link-vmlinux.sh b/scripts/link-vmlinux.sh
index b83f918c7830..71882648e064 100755
--- a/scripts/link-vmlinux.sh
+++ b/scripts/link-vmlinux.sh
@@ -93,9 +93,12 @@ kallsyms()
local aflags="${KBUILD_AFLAGS} ${KBUILD_AFLAGS_KERNEL} \
${NOSTDINC_FLAGS} ${LINUXINCLUDE} ${KBUILD_CPPFLAGS}"

- ${NM} -n ${1} | \
- scripts/kallsyms ${kallsymopt} | \
- ${CC} ${aflags} -c -o ${2} -x assembler-with-cpp -
+ # capture the return code of scripts/kallsyms in $RC
+ local RC=`(${NM} -n ${1} | \
+ (scripts/kallsyms ${kallsymopt}; echo $? 1>&3) | \
+ ${CC} ${aflags} -c -o ${2} -x assembler-with-cpp -) 3>&1`
+
+ [ $RC -eq 0 ]
}

# Create map file with all symbols from ${1}
--
2.5.0
\
 
 \ /
  Last update: 2016-02-04 18:41    [W:0.159 / U:1.052 seconds]
©2003-2020 Jasper Spaans|hosted at Digital Ocean and TransIP|Read the blog|Advertise on this site